#if defined(__linux__)
#if defined(__aarch64__)

/*
 * Use Linux system call.
 */

#define SYS_exit   1
#define SYS_read   3
#define SYS_write  4
#define SYS_open   5
#define SYS_close  6
#define SYS_ioctl 54

	.section .text

	.globl	_exit
	.type	_exit, %function
_exit:
	sub	sp, sp, #0x32
	str	x8, [sp, #0]
	mov	x8, #SYS_exit
	b	_syscall

	.globl	read
	.type	read, %function
read:
	sub	sp, sp, #0x32
	str	x8, [sp, #0]
	mov	x8, #SYS_read
	b	_syscall

	.globl	write
	.type	write, %function
write:
	sub	sp, sp, #0x32
	str	x8, [sp, #0]
	mov	x8, #SYS_write
	b	_syscall

	.globl	open
	.type	open, %function
open:
	sub	sp, sp, #0x32
	str	x8, [sp, #0]
	mov	x8, #SYS_open
	b	_syscall

	.globl	close
	.type	close, %function
close:
	sub	sp, sp, #0x32
	str	x8, [sp, #0]
	mov	x8, #SYS_close
	b	_syscall

	.globl	ioctl
	.type	ioctl, %function
ioctl:
	sub	sp, sp, #0x32
	str	x8, [sp, #0]
	mov	x8, #SYS_ioctl
	b	_syscall

_syscall:
	svc	0
	ldr	x8, [sp, #0]
	add	sp, sp, #0x32
	tbz	w0, #31, ret
err:	neg	w0, w0
	ldr	x1, _errno_addr
	str	w0, [x1]
	mov	w0, #0xffffffff
ret:	ret

	.align	8
_errno_addr:
	.quad	errno
#endif
#endif
